#ifndef MYLIB_H
#define MYLIB_H

#include <X11/Xlib.h>

typedef uchar m_colorarray[17];

typedef uchar m_vcolorarray[1000001L];

typedef struct m_chpicrec {
    int xsize : 8, ysize : 8, xoff : 8, yoff : 8;
    unsigned xdim : 8, ydim : 8, width : 8, height : 8;
    long pic[32];
} m_chpicrec;

typedef struct m_cchpicrec {
    int xsize : 8, ysize : 8, xoff : 8, yoff : 8;
    unsigned xdim : 8, ydim : 8, width : 8, height : 8;
    uchar pic[32][32];
} m_cchpicrec;

typedef struct m_tablet_info {
    long x, y;
    short phx, phy, fill1;
    int ax : 8, ay : 8;
    unsigned menu : 8, depressed : 1, near_ : 1, dn : 1, up : 1, off : 1, clip : 1,
             moving : 1, inalpha : 1;
} m_tablet_info;



#define m_black         0
#define m_red           1
#define m_green         2
#define m_yellow        3
#define m_blue          4
#define m_purple        5
#define m_cyan          6
#define m_white         7
#define m_xblack        16
#define m_xred          17
#define m_xgreen        18
#define m_xyellow       19
#define m_xblue         20
#define m_xpurple       21
#define m_xcyan         22
#define m_xwhite        23
#define m_normal        0
#define m_xor           16
#define m_over          32
#define m_mask          48
#define m_add           64
#define m_sub           80
#define m_user          96

#define m_scan          0xf8f8L
#define m_erase         0xf9f9L
#define m_hitdet        0xfafaL
#define m_chg           0xfbfbL
#define m_chgtab        0xfcfcL
#define m_pat           0xfdfdL
#define m_fastu         0xfefeL
#define m_trans         0xffffL

#define m_mode          256
#define m_rule_erase    0
#define m_rule_and      1
#define m_rule_normal   3
#define m_rule_mask     4
#define m_rule_trans    5
#define m_rule_xor      6
#define m_rule_over     7
#define m_rule_not      10
#define m_rule_inv      12
#define m_rule_ones     15
#define m_pie           1
#define m_chord         2
#define m_extarc        3

#define       DISPLAY_NAME_LENGTH 100

long m_hitcount, m_across, m_down;
long m_maxcolor;
Display *m_display;
Window m_window;
int m_initialized;
int BlackAndWhite;
int screennum;

#define ColorsInSet           16
#define ColorSets              4
XColor m_colors[ColorSets+1][ColorsInSet];

/* Added X display name support.  stafford 7/17/91 */
void m_set_display_name(char* display_name);
char m_display_name[DISPLAY_NAME_LENGTH];
int m_autoraise;

void m_init_screen ();
void m_init_colors ();
void m_init_graphics ();
void m_clear ();
void m_clip (int, int, int, int);
void m_noclip ();
void m_unclip();	
void m_transform (int, int, int, int, int, int, int);
void m_upside_down ();
void m_rotscale (double, double, int, int);
void m_rotscaled (double, double, int, int);
void m_notransform ();
void m_untransform();
void m_cursor (int, int);
void m_nocursor ();
void m_choosecursor (int);
void m_color (int);
void m_colormode (int c);
long m_curcolor ();
long m_curcolormode ();
void m_setcolor();
void m_seecolor (int, int *, int *, int *);
void m_setcolors (m_colorarray, m_colorarray, m_colorarray);
void m_seecolors (m_colorarray, m_colorarray, m_colorarray);
void m_vsetcolors (int, int, m_vcolorarray, m_vcolorarray, m_vcolorarray);
void m_vseecolors (int, int, m_vcolorarray, m_vcolorarray, m_vcolorarray);
void m_choosecolors (int);
void m_linestyle (int);
void m_setlinestyle (int, int);
void m_move (int, int);
void m_move2 (int, int);
void m_draw (int, int);
void m_drawrel (int, int);
void m_drawline (int, int, int, int);
void m_drawrect (int, int, int, int);
void m_fillrect (int, int, int, int);
void m_grid (int, int, int, int, int, int, int, int);
void m_drawpoint (int, int);
void m_circle (int, int, int);
void m_ellipse (int, int, int, int, int);
void m_drawarc (long, long, long, long, double, double, double, long);
void m_fillarc (long, long, long, long, double, double, double, long);
void m_roundrect (int, int, int, int, int, int, int);
void m_bezier (int, int, int, int, int, int, int, int);
void m_bezier2 (int, int, int, int, int, int, int, int, int);
void m_cbezier (int, int, int, int, int, int, int, int, int);
void m_polycurve (double, double, double, double, double, double, double, double, double, double, double, double);
void m_drawpoly (int, int [], int []);
void m_fillpoly (int, int [], int []);
void m_drawstr (int, int, char *, char *);
void m_centerstr (int, int, char *, char *);
void m_rightstr (int, int, char *, char *);
long m_strwidth (char *, char *);
void m_setfont();
void m_seefont();
void m_graphics_on();
void m_alpha_on();
void m_displaytext(char *str);

#define m_graphics_off()
#define m_alpha_off()

void m_readpen();
void m_trackpen();
void m_waitpen();
void m_clipxy();
int m_pollkbd();
uchar m_inkey();
uchar m_inkeyn();
uchar m_testkey();

#endif /*MYLIB_H*/



