#ifndef NEWCRT_H
#define NEWCRT_H
#include <X11/Xlib.h>
#include <utils/p2c.h>
#include <stdio.h>

/* Caged_date="r      nc_revision='V1.01: $X';" */
#define nc_revision     "V1.01: Dec 17, 1988 11:00 pm"


short XPOS, YPOS;

/// Window record
typedef struct nc_windowRec {
    short top; /// @todo Clip region or window dimensions ?
	short height;
	short left;
	short width;
    long area;
    short font;
	short gcolor;
	short gtop;
	short gheight;
	short gleft;
	short gwidth;
	short gminx;
	short gmaxx;
	short gminy;
	short gmaxy;
	short goffx; ///< X Offset to add for gLine
	short goffy; ///< Y Offset to add for gLine
	short savex; ///< Saved value of xpos
	short savey; ///< Saved value of ypos
	short saveHigh;
    long saveSize; ///< Number of bytes needed to save window
    void* *saveArea; ///< NIL or pointer to save area
} nc_windowRec;

/// Character re-mapping stuff
typedef short nc_maparray[256];



#define nc_maxFonts     4



/// Font information
typedef struct nc_fontRec {
    short foffset, fwidth, fheight;
} nc_fontRec;



/*nc_windows : array[0..nc_maxWindows] of nc_windowRec;*/
/* Exciting colors */
#define nc_green        0
#define nc_yellow       4096
#define nc_black        8192
#define nc_red          12288
#define nc_cyan         16384
#define nc_white        20480
#define nc_blue         24576
#define nc_purple       28672

/* Exciting attributes */
#define nc_inv          256
#define nc_blink        512
#define nc_under        1024
#define nc_half         2048

/* Exciting displays */
#define nc_g26          0
#define nc_g36          2
#define nc_g36c         4
#define nc_g300         6

/* #define nc_fontwidth 8 */
#define nc_fontwidth 8
#define nc_fontheight 13


/* Command translation */

typedef char nc_commandArray[256];



typedef union nc_crtword {
    struct {
      char h, c;
    } U1;
    short i;
} nc_crtword;

typedef nc_crtword nc_scrtype[];



/* call nc_refreshXY, etc after changing! */
/* New, improved Colors to eliminate Mylib conflicts. */

typedef uchar nc_colorarray[3][256];


#ifndef NEWCRT_G
nc_windowRec *nc_curWindow;
nc_windowRec *nc_mainWindow, *nc_lastLineWindow, *nc_statusWindow,
                    *nc_defaultWindow;
#endif
int nc_text_in_window;
Window nc_window;
int nc_initialized;
GC nc_gc;
short nc_highlight, nc_defaultHighlight;
nc_windowRec *nc_tempWindow;
nc_fontRec nc_fonts[nc_maxFonts + 1];
char *nc_commands;
_PROCEDURE nc_startAlphaHook, nc_endAlphaHook;

struct {
    short left; ///< left edge of main window
	short top; ///< top of main window
	short xincr; ///< pixels/character in X
	short yincr; ///< pixels/character in Y
	short width; ///< real width of hardware
	short height; ///< real height of hardware
	short colors; ///< number of graphics colors
	short gColors; ///< number of available graphics colors
} nc_g;

nc_crtword *nc_screen;
uchar (*nc_colors)[256];


/* Simulation routines.  Should GO AWAY. */
void nc_scrollDown ();
void nc_scrollUp ();
void nc_setWindow (int s, int l);
void nc_revCheck (char *rev);
void nc_setbeep (int b);
short nc_getNumPlanes ();
short nc_getAlphaPlanes ();
void nc_setAlphaPlanes (int num);
short nc_getGraphicsPlanes ();
void nc_setGraphicsPlanes (int num);
int nc_alphashared ();
void nc_sharealpha (int b);
void nc_setAlpha (int on);
void nc_setGraphics (int on);
short nc_getPlanes ();
void nc_setPlanes (int mask);
void nc_putChar (int x, int y, int c);
void nc_putChars (int x, int y, int len, char *c);
void nc_putStr (int x, int y, char *s);
void nc_writeStr (int x, int y, char *s);
char nc_getChar (int x, int y);
void nc_getChars (int x, int y, int len, char *c);
void nc_getStr (int x, int y, char *s);
short nc_getHighlight (int x, int y);
void nc_setHighlight (int high);
void nc_writeHighlight (int x, int y, int len, int newhigh);
void nc_orHighlight (int x, int y, int len, int newhigh);
void nc_andnotHighlight (int x, int y, int len, int newhigh);
void nc_putWord (int x, int y, int w);
void nc_putWords (int x, int y, int len, short *w);
short nc_getWord (int x, int y);
void nc_getWords (int x, int y, int len, short *w);
void nc_makeWindow (nc_windowRec *w, int ptop, int pheight,
			      int pleft, int pwidth);
void nc_setWindow_ (nc_windowRec *w);
void nc_saveWindow ();
void nc_restoreWindow ();
void nc_exchangeWindow ();
void nc_refreshON ();
void nc_refreshOFF ();
void nc_refreshXY (int x, int y, int dx, int dy);
void nc_refreshWindow ();
void nc_refreshScreenXY (int x, int y, int dx, int dy);
void nc_refreshScreen ();
short nc_gType ();
void nc_aCMap (int col, int r, int g, int b);
void nc_defaCMap ();
void nc_gCMap (int col, int r, int g, int b);
void nc_defgCMap ();
void nc_gColor (int col);
void nc_gLine (int x1, int y1, int x2, int y2);
void nc_gFillRect (int x1, int y1, int x2, int y2);
void nc_gBlit (int repl_rule, int dox, int doy, int sox, int soy,
			 int width, int height);
void nc_gClear ();
void nc_gClipToWindow (int x1, int y1, int x2, int y2);
void nc_gClipToHardware (int x1, int y1, int x2, int y2);
void nc_clearXY (int x, int y, int dx, int dy);
void nc_clear ();
void nc_scrollUp_ ();
void nc_scrollDown_ ();
void nc_scrollLeft ();
void nc_scrollRight ();
void nc_scrollXY (int dx, int dy);
void nc_insChar (int x, int y, int numChars);
void nc_insLine (int y, int numLines);
void nc_getXY (long *x, long *y);
void nc_setXY (int x, int y);
void nc_gotoXY (int x, int y);
void nc_cursXY (int x, int y);
void nc_cursor_on();
void nc_cursor_off();
void nc_nothing ();
void nc_unInit ();
void nc_init ();
void nc_setDevice (long newDevice);


/* added for C99 clang compatibility */

void nc_putchar (uchar c);
void nc_puts (char * s);
char *nc_fgets (char *s, int n, FILE *stream);
void nc_printf (char * fmt, ...);

#endif /*NEWCRT_H*/



