#include "box.h"
#include "logglobals.h"
#include "window.h"
#include "log.h"
#include "utils.h"
#include "keyboard.h"
#include "pen.h"

/// Link box to the current page.
void linkbox(log_brec *b)
{
	b->next = gg.pages[gg.curpage - 1]->bbase;
	gg.pages[gg.curpage - 1]->bbase = b;
	stamp(&gg.boxstamp);
}

/// Creates a Box
void newbox(log_brec **b)
{
	*b = (log_brec *)Malloc(sizeof(log_brec));
	(*b)->temp = (na_long)0;
	linkbox(*b);
}

/// Unlink box from the pages.
void unlinkbox(log_brec *b)
{
	log_brec *b1;

	b1 = gg.pages[gg.curpage - 1]->bbase;
	while (b1 != NULL && b1->next != b)
		b1 = b1->next;
	if (b1 == NULL)
		gg.pages[gg.curpage - 1]->bbase = b->next;
	else
		b1->next = b->next;
	chpageplace(gg.pages[gg.curpage - 1], b->x1, b->y1, b->x2, b->y2);
	stamp(&gg.boxstamp);
}

/// Dispose of a dashed box.
void dispbox(log_brec **b)
{
	unlinkbox(*b);
	Free(*b);
}

/// Create a new dashed box.
void addboxat(short x1, short y1, short x2, short y2)
{
	log_brec *b;

	newbox(&b);
	sortshints(&x1, &x2);
	sortshints(&y1, &y2);
	b->x1 = x1;
	b->y1 = y1;
	b->x2 = x2;
	b->y2 = y2;
	remcursor();
	clipon();
	drawboxc(b, gg.color.dashbox);
	clipoff();
	chpageplace(gg.pages[gg.curpage - 1], x1, y1, x2, y2);
	gg.nearbox = b;
}


void addbox()
{
	short x1, y1;

	log_setmode("BOX");
	clearfunc();
	cursortype = boxcursor;
	waitnear();
	do
	{
		do
		{
			pass();
			trykbdscroll();
			pen();
		} while (!gg.t.dn && gg.stillnear && *gg.func == '\0');
		gg.posx = gg.gridx;
		gg.posy = gg.gridy;
		if (gg.incircuit && gg.stillnear && *gg.func == '\0')
		{
			x1 = gg.posx;
			y1 = gg.posy;
			do
			{
				pen();
				x1 = gg.gridx;
				y1 = gg.gridy;
				m_colormode((long)m_xor);
				m_color((long)gg.color.dashbox);
				m_linestyle(1L);
				rect(gg.posx, gg.posy, x1, y1);
				m_linestyle(0L);
				m_colormode((long)m_normal);
				do
				{
					pass();
					trykbd();
					pen();
				} while (gg.gridx == x1 && gg.gridy == y1 && gg.t.depressed && *gg.func == '\0');

				m_colormode((long)m_xor);
				m_color((long)gg.color.dashbox);
				m_linestyle(1L);
				rect(gg.posx, gg.posy, x1, y1);
				m_linestyle(0L);
				m_colormode((long)m_normal);
				scroll();
			} while (gg.t.depressed || abs(x1 - gg.posx) < 2 || abs(y1 - gg.posy) < 2);
			sortshints(&gg.posx, &x1);
			sortshints(&gg.posy, &y1);
			remcursor();
			if (gg.incircuit && *gg.func == '\0')
				addboxat(gg.posx, gg.posy, x1, y1);
		}
	} while (gg.incircuit && gg.stillnear && *gg.func == '\0');
	gg.startpoint = false;
	log_setmode("");
	if (gg.t.dn && !gg.incircuit)
	{
		gg.t.dn = false;
		gg.t.depressed = false;
	}
	cursortype = normal;
}

